package edu.tum.motras.algorithms.util;

import java.util.Arrays;

import edu.tum.xmts.State;

public class StatePair {

	State[] states;

	public StatePair(State state1, State state2) {
		states = new State[] { state1, state2 };
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		StatePair other = (StatePair) obj;
		if (!Arrays.equals(states, other.states)) {
			return false;
		}
		return true;
	}

	public State get(int i) {
		return states[i - 1];
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + Arrays.hashCode(states);
		return result;
	}

	@Override
	public String toString() {
		return "StatePair [states=" + Arrays.toString(states) + "]";
	}
}
