package edu.tum.motras.legacy.pmtsrc.util.formula;

final public class Literal extends TreeBoolean {
	public boolean negated;
	public final int variable;

	Literal(int v) {
		this(v, false);
	}

	Literal(int v, boolean n) {
		variable = v;
		negated = n;
	}

	/* Special Constant Constructor */
	Literal(boolean bool) {
		this(-1, bool);
	}

	@Override
	public <R> R accept(Visitor<R> visitor) {
		return visitor.visit(this);
	}

	@Override
	public void accept(VoidVisitor visitor) {
		visitor.visit(this);
	}

	@Override
	public TreeBoolean clone() {
		return new Literal(variable, negated);
	}

	boolean isTrue() {
		if (variable == -1 && negated == true) {
			return true;
		}

		return false;
	}

	boolean isFalse() {
		if (variable == -1 && negated == false) {
			return true;
		}

		return false;
	}

	@Override
	public String toString() {
		return "Literal [" + (negated ? "-" : "") + variable + "]";
	}
}