package edu.tum.motras.legacy.pmtsrc.util.formula;

import java.util.Collection;
import java.util.IdentityHashMap;
import java.util.Map;

public class LiteralFactory<K> extends AbstractLiteralFactory {

	private final Map<K, Integer> map;

	public LiteralFactory(Domain domain) {
		super(domain);
		map = new IdentityHashMap<>();
	}

	public LiteralFactory(Domain domain, Collection<K> keys) {
		super(domain);
		map = new IdentityHashMap<>(keys.size() + 1);

		startInitialization();

		for (K key : keys) {
			getLiteral(key);
		}

		finishInitialization();
	}

	public Literal getLiteral(K key) {
		return new Literal(getVariable(map, key));
	}
}
