package edu.tum.motras.algorithms.junit;

import static org.junit.Assert.assertTrue;

import java.util.EnumSet;

import org.junit.Before;
import org.junit.Test;

import edu.tum.motras.algorithms.LTLChecker;
import edu.tum.xmts.TransitionSystem;
import edu.tum.xmts.TransitionSystem.Type;
import edu.tum.xmts.utils.XMTSReader;

public class LTLCheckerTest {

	private LTLChecker ltlChecker;

	@Before
	public void setUp() throws Exception {
		ltlChecker = new LTLChecker("");
	}

	@Test
	public void testGetArity() {
		AlgorithmTestUtil.testGetArity(ltlChecker, 1);
	}

	@Test
	public void testGetSupportedTypes() {
		AlgorithmTestUtil.testGetSupportedTypes(ltlChecker, EnumSet.of(Type.MTS, Type.DMTS));
	}

	@Test
	public void testApply() throws Exception {
		String xmts = "dmts machine [action coin action tea action coffee action hotChocolate action output "
				+ "state Idle [obligation all coin->Select] "
				+ "state Select [obligation (tea.Work | coffee.Work) hotChocolate -> Work tea->Work coffee->Work] "
				+ "state Work [obligation all output->Idle]]";

		XMTSReader reader = new XMTSReader();

		TransitionSystem transitionSystem = reader.read(xmts);
		ltlChecker = new LTLChecker("G ! coffee");
		assertTrue(ltlChecker.apply(transitionSystem.states.lookup("Idle")));
	}
}
